package GUIServer;

import java.io.*;
import java.net.*;
import java.util.*;


public class GenerateConfig{

    public GenerateConfig(){
    }
    
    public GenerateConfig(Socket in_socket){
	
	try{
	    
	    QueryReportBuffer mybuffer = QueryReportBuffer.getInstance();

	    OutputStream o = in_socket.getOutputStream();
	    
	    PrintWriter myout = new PrintWriter(o, true);
	    
	    myout.println("<HTML>  <HEAD>");
	    myout.println("<TITLE>Configure Wireless Data Sharing Network</TITLE>  </HEAD> <FONT face=\"arial black\" size=4 color=\"blue\"><CENTER> <H3>Customize Wireless Data Sharing Network</H3></CENTER><BR><CENTER> <BODY bgcolor=\"white\" text=\"navy\" marginwidth=\"0\" marginheight=\"0\" leftmargin=\"0\" topmargin=\"0\">");

	    myout.println("<FORM ACTION=\"http://localhost:9009/APPLYCONFIG\"><Table>");

	    myout.println("<TR><TD>Update View Frequency (seconds):</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"UPDATEFREQ\" SIZE=3 VALUE=\"" + mybuffer.updatefreq + "\"></TD></TR>");
	    
	    myout.println("<TR><TD>Broadcast Query Frequency (seconds):</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"BROADCASTFREQ\" SIZE=3 VALUE= \"" + mybuffer.broadcastfreq + "\"></TD></TR>");

	    myout.println("<TR><TD>Broadcast Query Limit (broadcasts):</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"NUMBROADCASTS\" SIZE=3 VALUE= \"" + mybuffer.numbroadcasts + "\"></TD></TR>");
	    
	    myout.println("<TR><TD>Retrieve Pages Frequency (seconds):</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"BUFFERFREQ\" SIZE=3 VALUE=\"" + mybuffer.bufferfreq + "\"></TD></TR>");

	    myout.println("<TR><TD>Clean cache Frequency (minutes):</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"CLEANCACHE\" SIZE=3 VALUE=\"" + mybuffer.cleancache + "\"></TD></TR>");
	    
	    myout.println("<TR><TD>Cached Page Expiration (hours):</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"EXPIRES\" SIZE=3 VALUE=\"" + mybuffer.expires + "\"></TD></TR>");

	    myout.println("<TR><TD>Energy Management ON? (true/false):</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"ENERGY\" SIZE=6 VALUE=\"" + mybuffer.energy + "\"></TD></TR></Table>");
	    
	    myout.println("<CENTER>   <INPUT TYPE=\"SUBMIT\" VALUE=\"Apply\">  </CENTER></FONT> </FORM> </Body></CENTER></HTML> ");
	 
	    
	    
	}
	catch (IOException e) {System.err.println(e.getMessage());
	}
	
	
    }

    

    //This method takes a query report buffer and and a Printstream and outputs the 
    //queries and their results to the web page
    private void showQueries(Vector queries, PrintWriter myout){
	
	myout.println("<TABLE position=center><TR><TD></TD><TD>");
	myout.println("<pre>");
	
	//traverse all of the queries
	for (int i=0; i<queries.size(); i++){
	    Query qtemp = (Query)queries.elementAt(i);
	    //for each query, show the descriptor
	    if(qtemp.viewable){

		//print the query descriptor in blue

		String noSpace = qtemp.descriptor.replace(' ', '+');
		
		myout.println("<a href=\"expand:" + i + "\">");
		myout.println("<FONT color=\"brown\" size=4><B>Query " + i + ": " +  qtemp.descriptor + "</B></FONT>" );
		myout.println("</a>");

		if (qtemp.expanded){
		    //now print out all of the viewable reports
		    for(int j=0; j<qtemp.reports.size(); j++){
			Report rtemp = (Report)qtemp.reports.elementAt(j);
			if(rtemp.viewable){
			    myout.println("     " + rtemp.title);
			    myout.println("     " + rtemp.age);
			    myout.println("     <a href=\"" + rtemp.origURL + "\" " + "target=" + "\"" +  rtemp.title + "\" >" + rtemp.origURL  + "</a><BR><BR>");
			    
			}
			
		    }
		}
		myout.println("<BR>");
		
	    }
	    else{  //print the query descriptor alone in gray font
		myout.println("<FONT color=\"gray\" size=4>Query " + i + ": " +  qtemp.descriptor + "</FONT><BR><BR>" );
	    }
	}
	myout.println("</pre></TD></TR></TABLE>\n");

    }

}



