package GUIServer;

import java.net.*;
import java.io.*;
import java.lang.*;
import UDPMulticast.*;
import StartAllServers.*;
import HTTPMethods.*;

public class ServeFile {
    Socket client_to_server = null;
    String filename;
    public final boolean error = true;
    public final boolean no_error = false;

    //Constructor
    public ServeFile(Socket socket, String filename) {
	this.client_to_server = socket;
	this.filename = filename;
	
	
    }


    //when we get a set of keywords we will just issue a multicast boradcast
    public void fileSend() {

	try{
	    FileInputStream f = new FileInputStream(filename);
	    File ffile = new File(filename);
	    
	    byte[] contents = new byte[(int)ffile.length()];
	    try{
	    f.read(contents);
	    }catch(IOException e){
		System.err.println(e.getMessage());
	    }
	    try{
	    OutputStream os = client_to_server.getOutputStream();
	    os.write(contents);
	    os.close();
	    f.close();

	    }catch(IOException e){
		System.err.println(e.getMessage());
	    } 

	}catch(FileNotFoundException e){
	    System.err.println(e.getMessage());
	}
	    

    }


}
