package ProxyServer;
import java.net.*;
import java.io.*;
import java.lang.*;
import StartAllServers.Debug;
import StartAllServers.*;

public class ProxyServer {
    //I don't care if this is truly synchronized
    public static boolean HAVE_INTERNET = true;
   
    public ProxyServer() {
	 ServerSocket serverSock = null;
	 boolean listening = true;
	 int option = 0;
	 int server_port = StartAllServers.PROXY_SERVER_PORT;  //can change this to anything you want (almost)
    
	 //try to create a server socket
	try {
	    serverSock = new ServerSocket(server_port);
	} catch (IOException e) {
	    System.err.println("Port " + server_port + " is busy, " + e.getMessage());
	    System.exit(2);
	}
	
	//listen for clients
	while (listening) {
	    Socket client_to_proxySock = null;
if (Debug.DEBUG_ProxyServer == true) { 
 	 System.out.println("Accepting Connections on port "+ server_port); 
 	}
	    try {
		client_to_proxySock = serverSock.accept();
	    } catch (IOException e) {
	    System.err.println("Not accepting because " + e.getMessage());
	    }
	    
	    //make a new Thread to carry out each request
if (Debug.DEBUG_ProxyServer == true) { 
 	 System.out.println("The socket in proxy is:" + client_to_proxySock); 
 	}
	    new ServeThread(client_to_proxySock, option).start();
	  
	    
	}
	//close the server socket
	try {
	    serverSock.close();
	} catch (IOException e) {
	    System.err.println("Can't close because " + e.getMessage());
	}
    }


    //good to keep for testing
    public static void main(String[] args) {
	 ServerSocket serverSock = null;
	 boolean listening = true;
	 int option = 0;
	 int server_port = StartAllServers.PROXY_SERVER_PORT;  //can change this to anything you want (almost)
    
	 //try to create a server socket
	try {
	    serverSock = new ServerSocket(server_port);
	} catch (IOException e) {
	    System.err.println("Port " + server_port + " is busy, " + e.getMessage());
	    System.exit(2);
	}
	
	//listen for clients
	while (listening) {
	    Socket client_to_proxySock = null;
if (Debug.DEBUG_ProxyServer == true) { 
 	 System.out.println("Accepting Connections on port "+ server_port); 
 	}
	    try {
		client_to_proxySock = serverSock.accept();
	    } catch (IOException e) {
	    System.err.println("Not accepting because " + e.getMessage());
	    }
	    
	    //make a new Thread to carry out each request
if (Debug.DEBUG_ProxyServer == true) { 
 	 System.out.println("The socket in proxy is:" + client_to_proxySock); 
 	}
	    new ServeThread(client_to_proxySock, option).start();
	  
	    
	}
	//close the server socket
	try {
	    serverSock.close();
	} catch (IOException e) {
	    System.err.println("Can't close because " + e.getMessage());
	}
    }
			   
}
    
			       

    
