package GUIServer;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.reflect.*;
import Caching.*;


import StartAllServers.Debug;
public class GenerateDetails{

    public GenerateDetails(){
    }
    
    public GenerateDetails(Socket in_socket, String url){
	
	try{
	    
	    OutputStream o = in_socket.getOutputStream();
	    
	    PrintWriter myout = new PrintWriter(o, true);
	    
	    myout.println("<HTML>  <HEAD>");
	    myout.println("<TITLE>Buffer Entry Details</TITLE>  </HEAD>");
	    myout.println("<FONT face=\"arial black\" size=4 color=\"blue\"><CENTER> <H3>Mobile Data Sharing Cache Configurator</H3></CENTER><BR><BODY bgcolor=\"white\" text=\"navy\" marginwidth=\"0\" marginheight=\"0\" leftmargin=\"0\" topmargin=\"0\">");


	    //Get the cache buffer so we can pull the values out of it
	    CacheBuffer cb = CacheBuffer.getInstance();

	    BufferEntry be = cb.getBufferEntry(url);
	    
	    myout.println("<BR>URL:  " + be.getUrl() );
	    if(be.getModified() != null)
		myout.println("<BR>Modified:  " + be.getModified().toString() );
	    else 		myout.println("<BR>Modified:  " + be.getModified());
	    myout.println("<BR>Expiration:  " + be.getExpired() );
	    myout.println("<BR>Security:  " + be.getFolder() );
	    myout.println("</FONT></BODY></HTML>");
	    
	    
	}
	catch (IOException e) {System.err.println(e.getMessage());
	}
	
	
    }

}


