package Misc;
import java.lang.*;
import java.net.*;
import java.util.*;
import java.io.*;
import StartAllServers.Debug;
import StartAllServers.*;


public class AssignAdHocIPAddress 
{
    public AssignAdHocIPAddress(String device) 
	{
	    StringBuffer output_str = new StringBuffer();

	try {
	    //execute command and set-up streams
	    Runtime Current_RunTime = Runtime.getRuntime();
	    Process output = Current_RunTime.exec("/sbin/ifconfig " + " " + device + " " + generateRandomIP() + " netmask 255.255.248.0 broadcast 10.255.255.255"); 
	    InputStream in = output.getInputStream();
	    int b;
	    
	    //read from OutPutStream
	    while ((b = in.read()) > 0) {
		output_str.append((char) b);
	    }
	    
	    //close the stream we read from
	    in.close();
	    
	} catch (IOException e) {
	    System.err.println(e.getMessage());
	}
	
	//proof for all you skeptics
	if (Debug.DEBUG_Misc == true) { 
	    System.out.print("The output is: " + output_str); 
 	}
	}
    
    public String generateRandomIP() 
	{
	    StringBuffer temp = new StringBuffer();
	    temp.append("10.0.0.");
	    //temp.append((int) (Math.random() * 254) + ".");
	    //temp.append((int) (Math.random() * 254) + ".");
	    temp.append((int) (Math.random() * 253 + 1));
	    System.out.println("The IP Address of this machine is: " + temp.toString());
	    StartAllServers.AD_HOC_IP_ADDRESS = temp.toString();
	    return temp.toString();
	}
    
    public static void main(String[] argv) 
	{
	    AssignAdHocIPAddress as = new AssignAdHocIPAddress("wvlan0");
	}
}


	    
	    

	    
