package Misc;
import java.io.*;
import java.lang.*;

import StartAllServers.Debug;
public class BatteryChecker extends Thread {
    long HOW_OFTEN;
    
    public BatteryChecker(long how_often) {
	this.HOW_OFTEN = how_often;
    }

    public void run() {
	while(true) {
	    try {
		Battery bc = Battery.getInstance(10);
		bc.updateBatteryLevel();
		bc.printBatteryLevel();
		Thread.sleep(HOW_OFTEN);
	    } catch (InterruptedException e) {
		System.err.println("BatteryChecker: " + e.getMessage());
	    }
	}
    }
    
    public static void main(String argv[]) {
	new BatteryChecker(3000).start();
    }
   
}
