package Misc;
import java.lang.*;
import java.net.*;
import java.util.*;
import java.io.*;
import StartAllServers.Debug;
import StartAllServers.*;


public class CreateMulticastRoute 
{
    public CreateMulticastRoute(String device) 
	{
	    StringBuffer output_str = new StringBuffer();

	try {
	    //execute command and set-up streams
	    Runtime Current_RunTime = Runtime.getRuntime();
	    Process output = Current_RunTime.exec("/sbin/route add " + StartAllServers.REPORT_REQUEST_GROUP_ADDRESS + " " + device); 
	    InputStream in = output.getInputStream();
	    int b;
	    
	    //read from OutPutStream
	    while ((b = in.read()) > 0) {
		output_str.append((char) b);
	    }
	    
	    //close the stream we read from
	    in.close();
	    
	} catch (IOException e) {
	    System.err.println(e.getMessage());
	}
	
	//proof for all you skeptics
	if (Debug.DEBUG_Misc == true) { 
	    System.out.print("The output is: " + output_str); 
 	}
	}


    public static void main(String[] argv) 
	{
	   new CreateMulticastRoute("wvlan0");
	}
}

    
